<template>
  <div class="student-manage">
    <div class="part-box part-box-filter">
      <el-form ref="FilterForm" label-position="left" label-width="90px" inline>
        <secp-select
          v-model="filter"
          default-select-exam
          @exam-default="toPage(1)"
        ></secp-select>
        <el-form-item label="学院：">
          <college-select
            v-model="filter.collegeId"
            placeholder="学院"
          ></college-select>
        </el-form-item>
        <el-form-item label="专业：">
          <major-select
            v-model="filter.majorId"
            :college-id="filter.collegeId"
            cascader
            placeholder="专业"
          ></major-select>
        </el-form-item>
        <el-form-item label="班级：">
          <major-class-select
            v-model="filter.clazzId"
            :major-id="filter.majorId"
            cascader
            placeholder="班级"
          ></major-class-select>
        </el-form-item>
        <el-form-item label="姓名/学号：">
          <el-input
            style="width: 142px"
            v-model.trim="filter.queryParams"
            placeholder="姓名/学号"
            clearable
          ></el-input>
        </el-form-item>
        <el-form-item>
          <el-button
            v-if="checkPrivilege('button', 'select')"
            type="primary"
            @click="toPage(1)"
            >查询</el-button
          >
        </el-form-item>
      </el-form>
      <div class="box-justify">
        <div>
          <el-button
            v-if="checkPrivilege('button', 'delete')"
            type="danger"
            icon="el-icon-delete"
            @click="toBatchDelete"
            >批量删除</el-button
          >
          <el-button
            v-if="checkPrivilege('button', 'export')"
            type="primary"
            icon="el-icon-download"
            :loading="loading"
            @click="toExportStudent"
            >导出</el-button
          >
        </div>
        <div>
          <el-button
            v-if="checkPrivilege('button', 'import')"
            type="success"
            icon="el-icon-upload2"
            @click="toImport"
            >导入</el-button
          >
          <el-button
            v-if="checkPrivilege('button', 'import')"
            type="primary"
            icon="el-icon-s-order"
            @click="toDataTask"
            >导入结果查询</el-button
          >
          <el-button
            v-if="checkPrivilege('button', 'add')"
            type="primary"
            icon="el-icon-circle-plus-outline"
            @click="toAdd"
            >新增</el-button
          >
        </div>
      </div>
    </div>
    <div class="part-box part-box-pad">
      <el-table
        ref="TableList"
        :data="dataList"
        @selection-change="handleSelectionChange"
      >
        <el-table-column
          type="selection"
          fixed="left"
          width="55"
          align="center"
        ></el-table-column>
        <el-table-column
          type="index"
          label="序号"
          width="70"
          :index="indexMethod"
        ></el-table-column>
        <el-table-column prop="studentName" label="姓名"></el-table-column>
        <el-table-column prop="studentCode" label="学号"></el-table-column>
        <el-table-column prop="courseCode" label="课程代码"></el-table-column>
        <el-table-column prop="courseName" label="课程名称"></el-table-column>
        <el-table-column prop="phoneNumber" label="手机号" width="120">
          <span slot-scope="scope">{{
            scope.row.phoneNumber | defaultFieldFilter
          }}</span>
        </el-table-column>
        <el-table-column prop="collegeName" label="学院"></el-table-column>
        <el-table-column prop="majorName" label="专业"></el-table-column>
        <el-table-column prop="clazz" label="班级"></el-table-column>
        <el-table-column prop="createTime" label="创建时间" width="170">
          <span slot-scope="scope">{{
            scope.row.createTime | timestampFilter
          }}</span>
        </el-table-column>
        <el-table-column
          class-name="action-column"
          label="操作"
          width="100"
          fixed="right"
        >
          <template slot-scope="scope">
            <el-button
              v-if="checkPrivilege('link', 'edit')"
              class="btn-primary"
              type="text"
              @click="toEdit(scope.row)"
              >编辑</el-button
            >
            <el-button
              v-if="checkPrivilege('link', 'delete')"
              class="btn-danger"
              type="text"
              @click="toDelete(scope.row)"
              >删除</el-button
            >
          </template>
        </el-table-column>
      </el-table>
      <div class="part-page">
        <el-pagination
          background
          layout="total, sizes, prev, pager, next, jumper"
          :pager-count="5"
          :current-page="current"
          :total="total"
          :page-size="size"
          @current-change="toPage"
          @size-change="pageSizeChange"
        >
        </el-pagination>
      </div>
    </div>

    <modify-student
      :instance="curRow"
      @modified="getList"
      ref="ModifyStudent"
    ></modify-student>
    <!-- ImportFile -->
    <import-file
      v-if="checkPrivilege('button', 'import')"
      ref="ImportFile"
      title="导入学生"
      :upload-url="uploadUrl"
      :upload-data="{
        semesterId: filter.semesterId,
        examId: filter.examId,
      }"
      :format="['xls', 'xlsx']"
      :download-handle="() => downloadTemplate('student')"
      :download-filename="dfilename"
      :auto-upload="false"
      @upload-success="uploadSuccess"
    ></import-file>
    <!-- data-task-dialog -->
    <data-task-dialog
      v-if="checkPrivilege('button', 'import')"
      ref="DataTaskDialog"
      task-type="STUDENT_IMPORT"
    ></data-task-dialog>
  </div>
</template>

<script>
import { studentListQuery, deleteStudent, exportStudent } from "../api";
import ModifyStudent from "../components/ModifyStudent.vue";
import ImportFile from "../../../components/ImportFile.vue";
import { downloadByApi } from "@/plugins/download";
import templateDownload from "@/mixins/templateDownload";

export default {
  name: "student-manage",
  components: { ModifyStudent, ImportFile },
  mixins: [templateDownload],
  data() {
    return {
      filter: {
        semesterId: "",
        examId: "",
        queryParams: "",
        collegeId: "",
        majorId: "",
        clazzId: "",
      },
      queriedFilter: {},
      current: 1,
      size: this.GLOBAL.pageSize,
      total: 0,
      dataList: [],
      multipleSelection: [],
      curRow: {},
      loading: false,
      // import
      uploadUrl: "/api/admin/basic/student/data_import",
      dfilename: "学生导入模板.xlsx",
    };
  },
  computed: {
    filterHasQuery() {
      return !Object.keys(this.filter).some(
        (k) => this.filter[k] !== this.queriedFilter[k]
      );
    },
  },
  methods: {
    async getList() {
      if (!this.checkPrivilege("list", "list")) return;

      const datas = {
        ...this.filter,
        pageNumber: this.current,
        pageSize: this.size,
      };
      const data = await studentListQuery(datas);
      this.dataList = data.records;
      this.total = data.total;
      this.queriedFilter = { ...this.filter };
    },
    toPage(page) {
      this.current = page;
      this.getList();
    },
    handleSelectionChange(val) {
      this.multipleSelection = val.map((item) => item.id);
    },
    toAdd() {
      this.curRow = {
        semesterId: this.filter.semesterId,
        examId: this.filter.examId,
      };
      this.$refs.ModifyStudent.open();
    },
    toEdit(row) {
      this.curRow = row;
      this.$refs.ModifyStudent.open();
    },
    async toBatchDelete() {
      if (!this.multipleSelection.length) {
        this.$message.error("请选择要删除的学生");
        return;
      }
      const confirm = await this.$confirm(
        `确定要删除当前选择的所有学生吗?`,
        "提示",
        {
          type: "warning",
        }
      ).catch(() => {});

      if (confirm !== "confirm") return;

      await deleteStudent(this.multipleSelection);
      this.$message.success("删除成功！");
      this.deletePageLastItem();
    },
    toDelete(row) {
      this.$confirm(`确定要删除学生【${row.studentName}】吗?`, "提示", {
        type: "warning",
      })
        .then(async () => {
          await deleteStudent([row.id]);
          this.$message.success("删除成功！");
          this.deletePageLastItem();
        })
        .catch(() => {});
    },
    async toExportStudent() {
      if (this.loading) return;

      this.loading = true;
      const res = await downloadByApi(() => {
        return exportStudent(this.filter);
      }, "").catch((e) => {
        this.$message.error(e || "下载失败，请重新尝试！");
      });
      this.loading = false;

      if (!res) return;
      this.$message.success("下载成功！");
    },
    // import
    toImport() {
      this.$refs.ImportFile.open();
    },
    toDataTask() {
      this.$refs.DataTaskDialog.open();
    },
    validError(errorData) {
      this.$message.error(errorData.message);
    },
    uploadSuccess() {
      this.$message.success("文件上传成功，后台正在导入！");
      this.getList();
    },
  },
};
</script>
